/**
 * @file
 * VuoGradientNoiseCommon interface.
 *
 * @copyright Copyright © 2012–2013 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#include "node.h"

VuoReal perlinNoise1d(VuoReal x);
VuoReal perlinNoise2d(VuoReal x, VuoReal y);
VuoReal perlinNoise3d(VuoReal x, VuoReal y, VuoReal z);
VuoReal perlinNoise4d(VuoReal x, VuoReal y, VuoReal z, VuoReal w);

VuoReal simplexNoise1d(VuoReal x);
VuoReal simplexNoise2d(VuoReal x, VuoReal y);
VuoReal simplexNoise3d(VuoReal x, VuoReal y, VuoReal z);
VuoReal simplexNoise4d(VuoReal x, VuoReal y, VuoReal z, VuoReal w);

VuoReal grad1d(int hash, VuoReal x);
VuoReal grad2dPerlin(int hash, VuoReal x, VuoReal y);
VuoReal grad2dSimplex(int hash, VuoReal x, VuoReal y);
VuoReal grad3d(int hash, VuoReal x, VuoReal y, VuoReal z);
VuoReal grad4dPerlin(int hash, VuoReal x, VuoReal y, VuoReal z, VuoReal w);
VuoReal grad4dSimplex(int hash, VuoReal x, VuoReal y, VuoReal z, VuoReal t);

VuoReal fade(VuoReal t);
VuoReal lerp(VuoReal t, VuoReal a, VuoReal b);
