/**
 * @file
 * VuoSceneParametricVertices interface.
 *
 * @copyright Copyright © 2012–2013 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifdef __cplusplus
extern "C"
{
#endif

#include "node.h"

VuoList_VuoVertices VuoSceneParametricVertices_generate( char* xExp, char* yExp, char* zExp, char* uExp, char* vExp, VuoInteger uSubdivisions, VuoInteger vSubdivisions, bool closeU, bool closeV );

VuoPoint4d VuoSceneParametricVertices_faceNormal(VuoPoint4d a, VuoPoint4d b, VuoPoint4d c);
void CalculateTangentArray(int vertexCount, const VuoPoint4d *vertex, const VuoPoint4d *normal,
						   const VuoPoint4d *texcoord, int triangleCount, const int *triangle, VuoPoint4d *tangent, VuoPoint4d *bitangent);
#ifdef __cplusplus
}
#endif
