/**
 * @file
 * TestGraphExecution interface.
 *
 * @copyright Copyright © 2012–2013 Kosada Incorporated.
 * This interface description may be modified and distributed under the terms of the GNU Lesser General Public License (LGPL) version 2 or later.
 * For more information, see http://vuo.org/license.
 */

#ifndef TESTGRAPHEXECUTION_H
#define TESTGRAPHEXECUTION_H

#include <fstream>
#include <QtTest>
#include <Vuo/Vuo.h>

/**
 * This base class provides common methods for testing that graphs run correctly.
 */
class TestGraphExecution : public QObject
{
	Q_OBJECT

public:
	static QDir getCompositionDir(void);
	static string getCompositionPath(string compositionFileName);

protected:
	static VuoCompiler * initCompiler(void);

};

#endif
