TEMPLATE = subdirs
QMAKE_CLEAN = Makefile

SUBDIRS += \
	base \
	base_vuo_debug \
	compiler \
	compiler_vuo_compile \
	compiler_vuo_link \
	framework \
	node \
	renderer \
	renderer_vuo_render \
	runtime \
	type_list \
	type

OTHER_FILES += \
	vuo.pri


base_vuo_debug.subdir = base/vuo-debug
base_vuo_debug.depends = base

compiler.depends = base

compiler_vuo_compile.subdir = compiler/vuo-compile
compiler_vuo_compile.depends = compiler

compiler_vuo_link.subdir = compiler/vuo-link
compiler_vuo_link.depends = framework

framework.subdir = framework
framework.depends = base compiler renderer runtime node type type_list

node.depends = compiler_vuo_compile type type_list

renderer.depends = base compiler

renderer_vuo_render.subdir = renderer/vuo-render
renderer_vuo_render.depends = compiler renderer

type.depends = compiler_vuo_compile

type_list.subdir = type/list
type_list.depends = type


exists(editor) {
	SUBDIRS += \
		editor \
		editor_DataEditors_VuoDataEditorInteger \
		editor_DataEditors_VuoDataEditorReal \
		editor_DataEditors_VuoDataEditorCurve \
		editor_DataEditors_VuoDataEditorGradientNoise \
		editor_DataEditors_VuoDataEditorNoise \
		editor_DataEditors_VuoDataEditorCurveDomain \
		editor_DataEditors_VuoDataEditorWave \
		editor_DataEditors_VuoDataEditorText \
		editor_VuoEditor

	editor.depends = compiler renderer

	editor_DataEditors_VuoDataEditorInteger.subdir = editor/DataEditors/VuoDataEditorInteger
	editor_DataEditors_VuoDataEditorInteger.depends = editor

	editor_DataEditors_VuoDataEditorReal.subdir = editor/DataEditors/VuoDataEditorReal
	editor_DataEditors_VuoDataEditorReal.depends = editor

	editor_DataEditors_VuoDataEditorCurve.subdir = editor/DataEditors/VuoDataEditorCurve
	editor_DataEditors_VuoDataEditorCurve.depends = editor

	editor_DataEditors_VuoDataEditorGradientNoise.subdir = editor/DataEditors/VuoDataEditorGradientNoise
	editor_DataEditors_VuoDataEditorGradientNoise.depends = editor

	editor_DataEditors_VuoDataEditorNoise.subdir = editor/DataEditors/VuoDataEditorNoise
	editor_DataEditors_VuoDataEditorNoise.depends = editor

	editor_DataEditors_VuoDataEditorCurveDomain.subdir = editor/DataEditors/VuoDataEditorCurveDomain
	editor_DataEditors_VuoDataEditorCurveDomain.depends = editor

	editor_DataEditors_VuoDataEditorWave.subdir = editor/DataEditors/VuoDataEditorWave
	editor_DataEditors_VuoDataEditorWave.depends = editor

	editor_DataEditors_VuoDataEditorText.subdir = editor/DataEditors/VuoDataEditorText
	editor_DataEditors_VuoDataEditorText.depends = editor

	editor_VuoEditor.subdir = editor/VuoEditorApp
	editor_VuoEditor.depends = \
		editor \
		editor_DataEditors_VuoDataEditorInteger \
		editor_DataEditors_VuoDataEditorReal \
		editor_DataEditors_VuoDataEditorCurve \
		editor_DataEditors_VuoDataEditorGradientNoise \
		editor_DataEditors_VuoDataEditorNoise \
		editor_DataEditors_VuoDataEditorCurveDomain \
		editor_DataEditors_VuoDataEditorWave \
		editor_DataEditors_VuoDataEditorText \
		framework
}


# Provide "make go" for easily running the editor from the command line
go.commands = (cd "editor/VuoEditorApp/Vuo*.app/Contents/MacOS" ; ./Vuo*)
QMAKE_EXTRA_TARGETS += go

# Provide "make examples" so we don't need to rebuild all the examples during development
DOLLAR = $
examples.commands = (for i in example/api/* ; do (cd $${DOLLAR}$${DOLLAR}i && ([ -f Makefile ] || qmake) && make -j9); done)
examples.commands += && (cd example/graph && ([ -f Makefile ] || qmake) && make -j9)
QMAKE_EXTRA_TARGETS += examples

# Provide "make documentation" so we don't need to rebuild the documentation during development
docs.commands = (cd documentation && ([ -f Makefile ] || qmake) && make -j9);
QMAKE_EXTRA_TARGETS += docs

# Provide "make tests" so we don't need to rebuild the tests during development
tests.commands = (cd test && ([ -f Makefile ] || qmake) && make -j9 && make check);
QMAKE_EXTRA_TARGETS += tests

# Provide "make cleanall", which cleans the main project and all external subprojects
cleanall.commands = make clean
cleanall.commands += ; (for i in example/api/* ; do (cd $${DOLLAR}$${DOLLAR}i ; make clean ; rm -Rf Makefile pch *.app); done)
cleanall.commands += ; (cd example/graph && make clean)
cleanall.commands += ; (cd documentation && make clean)
cleanall.commands += ; (cd test && make clean)
cleanall.commands += ; true
QMAKE_EXTRA_TARGETS += cleanall
